From e480970e90be1fe046790bf6cfab1b31f5e76a4c Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Fri, 3 Feb 2012 12:25:10 -0600
Subject: Grade screen and grade selector.

---
 grade/report/quick_edit/classes/lib.php        |   61 ++++++++++++++++++++++++
 grade/report/quick_edit/index.php              |   14 ++----
 grade/report/quick_edit/screens/grade/lib.php  |   53 ++++++++++++++++++++
 grade/report/quick_edit/screens/select/lib.php |   36 ++++++++++++++
 4 files changed, 155 insertions(+), 9 deletions(-)
 create mode 100644 grade/report/quick_edit/screens/select/lib.php

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index 54c1171..c85021a 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -19,6 +19,67 @@ abstract class quick_edit_screen {
         $this->init();
     }
 
+    public function format_range($item) {
+        $decimals = $item->get_decimals();
+
+        $min = format_float($item->grademin, $decimals);
+        $max = format_float($item->grademax, $decimals);
+
+        return "$min - $max";
+    }
+
+    public function format_grade($grade, $decimals) {
+        $name = 'grade_' . $grade->itemid . '_' . $grade->userid;
+
+        $finalgrade = $grade->finalgrade ?
+            format_float($grade->finalgrade, $decimals) :
+            '';
+
+        $attributes = array(
+            'type' => 'text',
+            'name' => $name,
+            'value' => $finalgrade
+        );
+
+        $hidden = array(
+            'type' => 'hidden',
+            'name' => 'old' . $name,
+            'value' => $finalgrade
+        );
+
+        return (
+            html_writer::empty_tag('input', $attributes) .
+            html_writer::empty_tag('input', $hidden)
+        );
+    }
+
+    public function format_feedback($grade) {
+        $name = 'feedback_' . $grade->itemid . '_' . $grade->userid;
+
+        $feedback = $grade->feedback ?
+            format_text($grade->feedback, $grade->feedbackformat) :
+            '';
+
+        $attributes = array(
+            'type' => 'text',
+            'name' => $name,
+            'value' => $feedback
+        );
+
+        $hidden = array(
+            'type' => 'hidden',
+            'name' => 'old' . $name,
+            'value' => $feedback
+        );
+
+        return (
+            html_writer::empty_tag('input', $attributes) .
+            html_writer::empty_tag('input', $hidden)
+        );
+    }
+
+    public abstract function heading();
+
     public abstract function init();
 
     public abstract function html();
diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
index 60121b0..6e230d4 100755
--- a/grade/report/quick_edit/index.php
+++ b/grade/report/quick_edit/index.php
@@ -29,7 +29,7 @@ require_once $CFG->dirroot.'/grade/report/quick_edit/lib.php';
 
 $courseid = required_param('id', PARAM_INT);
 $itemtype = optional_param('item', 'select', PARAM_TEXT);
-$itemid = optional_param('itemid', 0, PARAM_INT);
+$itemid = optional_param('itemid', null, PARAM_INT);
 $groupid  = optional_param('group', null, PARAM_INT);
 
 $PAGE->set_url(new moodle_url('/grade/report/quick_edit/index.php', array(
@@ -57,10 +57,6 @@ require_capability('moodle/grade:viewall', $context);
 require_capability('moodle/grade:edit', $context);
 // End permission
 
-$_s = function($key, $a = null) {
-    return get_string($key, 'gradereport_quick_edit', $a);
-};
-
 $gpr = new grade_plugin_return(array(
     'type' => 'report', 'plugin' => 'quick_edit', 'courseid' => $courseid
 ));
@@ -72,16 +68,16 @@ $USER->grade_last_report[$course->id] = 'quick_edit';
 
 grade_regrade_final_grades($courseid);
 
-$reportname = $_s('pluginname');
-
 $PAGE->set_context($context);
 
-print_grade_page_head($course->id, 'report', 'quick_edit', $reportname, false);
-
 $report = new grade_report_quick_edit(
     $courseid, $gpr, $context, $itemtype, $itemid, $groupid
 );
 
+$reportname = $report->screen->heading();
+
+print_grade_page_head($course->id, 'report', 'quick_edit', $reportname, false);
+
 echo $report->output();
 
 echo $OUTPUT->footer();
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index c75d3bc..9b3ba16 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -18,5 +18,58 @@ class quick_edit_grade extends quick_edit_screen {
     }
 
     public function html() {
+        $table = new html_table();
+
+        $table->head = $this->headers();
+
+        $table->data = array();
+
+        foreach ($this->users as $user) {
+            $table->data[] = $this->format_line($user);
+        }
+
+        return html_writer::table($table);
+    }
+
+    public function headers() {
+        return array(
+            '',
+            get_string('firstname') . ' / ' . get_string('lastname'),
+            get_string('range', 'grades'),
+            get_string('grade', 'grades'),
+            get_string('feedback', 'grades')
+        );
+    }
+
+    public function format_line($user) {
+        global $OUTPUT;
+
+        $grade = grade_grade::fetch(array(
+            'itemid' => $this->item->id, 'userid' => $user->id
+        ));
+
+        $fullname = fullname($user);
+
+        $user->imagealt = $fullname;
+
+        return array(
+            $OUTPUT->user_picture($user),
+            $fullname,
+            $this->item_range(),
+            $this->format_grade($grade, $this->item->get_decimals()),
+            $this->format_feedback($grade)
+        );
+    }
+
+    public function item_range() {
+        if (empty($this->range)) {
+            $this->range = $this->format_range($this->item);
+        }
+
+        return $this->range;
+    }
+
+    public function heading() {
+        return $this->item->itemname;
     }
 }
diff --git a/grade/report/quick_edit/screens/select/lib.php b/grade/report/quick_edit/screens/select/lib.php
new file mode 100644
index 0000000..413fb20
--- /dev/null
+++ b/grade/report/quick_edit/screens/select/lib.php
@@ -0,0 +1,36 @@
+<?php
+
+// TODO: custom form with group selector
+class quick_edit_select extends quick_edit_screen {
+    public function init() {
+        global $DB;
+
+        $params = array('courseid' => $this->courseid);
+
+        $filter_items = function($item) {
+            return $item->itemtype != 'course' and $item->itemtype != 'category';
+        };
+
+        $this->grade_items = array_filter(grade_item::fetch_all($params), $filter_items);
+
+        $this->item = $DB->get_record('course', array('id' => $this->courseid));
+    }
+
+    public function html() {
+        global $OUTPUT;
+
+        $map = function($item) { return $item->itemname; };
+
+        $grade_options = array_map($map, $this->grade_items);
+
+        $params = array(
+            'id' => $this->courseid,
+            'item' => 'grade',
+            'group' => $this->groupid
+        );
+
+        $url = new moodle_url('/grade/report/quick_edit/index.php', $params);
+
+        echo $OUTPUT->single_select($url, 'itemid', $grade_options, $this->itemid);
+    }
+}
-- 
1.7.1


